diff -crB c:\mame0106s\mame0106s\src/windows/input.c c:\mingw9\mame\src/windows/input.c
*** c:\mame0106s\mame0106s\src/windows/input.c	Thu May  4 09:19:00 2006
--- c:\mingw9\mame\src/windows/input.c	Tue Sep 10 21:26:20 2013
***************
*** 158,169 ****
  
  // Controller override options
  static float				a2d_deadzone;
  static int					use_joystick;
  static int					use_lightgun;
  static int					use_lightgun_dual;
  static int					use_lightgun_reload;
  static int					use_keyboard_leds;
! static const char *			ledmode;
  static int					steadykey;
  static UINT8				analog_type[ANALOG_TYPE_COUNT];
  static int					dummy[10];
--- 158,170 ----
  
  // Controller override options
  static float				a2d_deadzone;
+ static float				joy_saturation;
  static int					use_joystick;
  static int					use_lightgun;
  static int					use_lightgun_dual;
  static int					use_lightgun_reload;
  static int					use_keyboard_leds;
! static const char *				ledmode;
  static int					steadykey;
  static UINT8				analog_type[ANALOG_TYPE_COUNT];
  static int					dummy[10];
***************
*** 228,242 ****
  {
  	/* name, shortname, type, dest, deflt, min, max, func, help */
  	{ "Input device options", NULL, rc_seperator, NULL, NULL, 0, 0, NULL, NULL },
! 	{ "mouse", NULL, rc_bool, &win_use_mouse, "0", 0, 0, NULL, "enable mouse input" },
! 	{ "joystick", "joy", rc_bool, &use_joystick, "0", 0, 0, NULL, "enable joystick input" },
  	{ "lightgun", "gun", rc_bool, &use_lightgun, "0", 0, 0, NULL, "enable lightgun input" },
  	{ "dual_lightgun", "dual", rc_bool, &use_lightgun_dual, "0", 0, 0, NULL, "enable dual lightgun input" },
  	{ "offscreen_reload", "reload", rc_bool, &use_lightgun_reload, "0", 0, 0, NULL, "offscreen shots reload" },
  	{ "steadykey", "steady", rc_bool, &steadykey, "0", 0, 0, NULL, "enable steadykey support" },
  	{ "keyboard_leds", "leds", rc_bool, &use_keyboard_leds, "1", 0, 0, NULL, "enable keyboard LED emulation" },
  	{ "led_mode", NULL, rc_string, (char *)&ledmode, "ps/2", 0, 0, decode_ledmode, "LED mode (ps/2|usb)" },
! 	{ "a2d_deadzone", "a2d", rc_float, &a2d_deadzone, "0.3", 0.0, 1.0, NULL, "minimal analog value for digital input" },
  	{ "ctrlr", NULL, rc_string, (char *)&options.controller, 0, 0, 0, NULL, "preconfigure for specified controller" },
  	{ "paddle_device", "paddle", rc_string, &dummy[0], "keyboard", ANALOG_TYPE_PADDLE, 0, decode_analog_select, "enable (keyboard|mouse|joystick) if a paddle control is present" },
  	{ "adstick_device", "adstick", rc_string, &dummy[1], "keyboard", ANALOG_TYPE_ADSTICK, 0, decode_analog_select, "enable (keyboard|mouse|joystick|lightgun) if an analog joystick control is present" },
--- 229,246 ----
  {
  	/* name, shortname, type, dest, deflt, min, max, func, help */
  	{ "Input device options", NULL, rc_seperator, NULL, NULL, 0, 0, NULL, NULL },
! 	{ "mouse", NULL, rc_bool, &win_use_mouse, "1", 0, 0, NULL, "enable mouse input" },
! 	{ "joystick", "joy", rc_bool, &use_joystick, "1", 0, 0, NULL, "enable joystick input" },
  	{ "lightgun", "gun", rc_bool, &use_lightgun, "0", 0, 0, NULL, "enable lightgun input" },
  	{ "dual_lightgun", "dual", rc_bool, &use_lightgun_dual, "0", 0, 0, NULL, "enable dual lightgun input" },
  	{ "offscreen_reload", "reload", rc_bool, &use_lightgun_reload, "0", 0, 0, NULL, "offscreen shots reload" },
  	{ "steadykey", "steady", rc_bool, &steadykey, "0", 0, 0, NULL, "enable steadykey support" },
  	{ "keyboard_leds", "leds", rc_bool, &use_keyboard_leds, "1", 0, 0, NULL, "enable keyboard LED emulation" },
  	{ "led_mode", NULL, rc_string, (char *)&ledmode, "ps/2", 0, 0, decode_ledmode, "LED mode (ps/2|usb)" },
! 	{ "a2d_deadzone", "a2d", rc_float, &a2d_deadzone, "0.05", 0.0, 1.0, NULL, "minimal analog value for digital input" },
! 	{ "joy_saturation", "joysat", rc_float, &joy_saturation, "0.7", 0.0, 1.5, NULL, "increase/decrease the actual max steering angle"},
! 	{ "geartype", "gtype", rc_int, &options.geartype, "0", 0, 3, NULL, "0 - 2 way, 1 - 2way reversed, 2 - sequential"},
! 	{ "steertype", "stype", rc_bool, &options.steertype, "0", 0, 0, NULL, "0 - potentiometer (270°) steer, 1 - optical (360°) steer"},
  	{ "ctrlr", NULL, rc_string, (char *)&options.controller, 0, 0, 0, NULL, "preconfigure for specified controller" },
  	{ "paddle_device", "paddle", rc_string, &dummy[0], "keyboard", ANALOG_TYPE_PADDLE, 0, decode_analog_select, "enable (keyboard|mouse|joystick) if a paddle control is present" },
  	{ "adstick_device", "adstick", rc_string, &dummy[1], "keyboard", ANALOG_TYPE_ADSTICK, 0, decode_analog_select, "enable (keyboard|mouse|joystick|lightgun) if an analog joystick control is present" },
***************
*** 1863,1870 ****
  	int joyindex = JOYINDEX(joycode);
  	int codetype = CODETYPE(joycode);
  	int joynum = JOYNUM(joycode);
  	DWORD pov;
! 
  	// switch off the type
  	switch (codetype)
  	{
--- 1867,1899 ----
  	int joyindex = JOYINDEX(joycode);
  	int codetype = CODETYPE(joycode);
  	int joynum = JOYNUM(joycode);
+ 	float satconst;
  	DWORD pov;
! 	/* RacerMAME satfactor NEGATIVE SATCONST "SERVICE TEST DEFINED" (defined using operator manual specs)*/
!     if(!strncmp(Machine->gamedrv->name, "radr", 4)||!strncmp(Machine->gamedrv->name, "radm", 4)) {satconst=-0.14;} /*OPERATOR MANUAL SERVICE TEST DEFINED (0x30-0xD0)*/
!     else if(!strncmp(Machine->gamedrv->name, "enduror", 4)) {satconst=-0.24;} /*OPERATOR MANUAL SERVICE TEST DEFINED (0xB8-0x48)*/
!     else if(!strncmp(Machine->gamedrv->name, "scross", 4)) {satconst=-0.21;} /*OPERATOR MANUAL SERVICE TEST DEFINED (0xB5-0x45)*/
! 	/* RacerMAME satfactor NEGATIVE SATCONST */
!     else if(!strncmp(Machine->gamedrv->name, "chqflag", 5)) {satconst=-0.28;}/*0.7-0.28=0.42 best and "safe"; the lower value for chqflag is 0.30*/
!     else if(!strncmp(Machine->gamedrv->name, "gprider", 4)||!strncmp(Machine->gamedrv->name, "hangon", 4)) {satconst=-0.16;}/*gprider, tested with pad.*/
!     else if(!strncmp(Machine->gamedrv->name, "superchs", 5)) {satconst=-0.20;}/*0.7-0.24=0.46 lower for superchs*/
!     else if((options.steertype==0 && !strncmp(Machine->gamedrv->name, "hcrash", 5))) {satconst=-0.39;}/*0.7-0.39=0.31 best and "safe"*/
!     else if(!strncmp(Machine->gamedrv->name, "wecleman", 5)){satconst=-0.19;}/*0.7-0.39=0.31 best and "safe" (0.30 lower for WEC)*/
!     else if(!strncmp(Machine->gamedrv->name, "f1en", 4)||!strncmp(Machine->gamedrv->name, "slipstrm", 6)|| (options.steertype==0 &&!strncmp(Machine->gamedrv->name, "sci", 3)) || (options.steertype==0 && !strncmp(Machine->gamedrv->name, "gtmr", 4))) {satconst=-0.09;}/*0.7-0.09=0.61 good for all; "sci" works good in the range 0.5-0.7; fien and slipstrm tested with pad*/
!     else if(!strncmp(Machine->gamedrv->name, "topspeed", 6)||!strncmp(Machine->gamedrv->name, "fullthrl", 6)) {satconst=-0.14;}/*0.7-0.14=0.56 best and "safe" for all . Lower for all is 0.50.*/
!     /* RacerMAME satfactor POSITIVE SATCONST "SERVICE TEST DEFINED" (defined using operator manual specs)*/
!     else if(!strncmp(Machine->gamedrv->name, "outrun", 5)||!strncmp(Machine->gamedrv->name, "toutrun", 5)){satconst=0.26;} /*GENUINE ARCADE SERVICE TEST DEFINED (0x2C-0xDC)*/
!     else if(!strncmp(Machine->gamedrv->name, "shangon", 5)){satconst=0.01;} /*OPERATOR MANUAL SERVICE TEST DEFINED (0x3C-0xBE)*/
!     else if(!strncmp(Machine->gamedrv->name, "pdrift", 5)) {satconst=0.15;} /*OPERATOR MANUAL SERVICE TEST DEFINED (0xD0-0x30)*/
!     else if(!strncmp(Machine->gamedrv->name, "orunners", 7)){satconst=0.26;} /*OPERATOR MANUAL SERVICE TEST DEFINED (7H-F8H)*/
!     else if(!strncmp(Machine->gamedrv->name, "smgp", 4)) {satconst=0.20;} /*OPERATOR MANUAL SERVICE TEST DEFINED (0x20-0xE0)*/
!     /* RacerMAME satfactor POSITIVE SATCONST */
!    	else if(!strncmp(Machine->gamedrv->name, "rachero", 4)||!strncmp(Machine->gamedrv->name, "abcop", 4)){satconst=0.04;} /*tested with pad*/
!     else if(!strncmp(Machine->gamedrv->name, "f1gpst", 5)||!strncmp(Machine->gamedrv->name, "cischeat", 5)) {satconst=0.03;}/*"safe" for cischeat, tested on pad for f1gpstar 1 e 2*/
!     else if((options.steertype==0 && !strncmp(Machine->gamedrv->name, "polepos", 5))||(options.steertype==0 &&!strncmp(Machine->gamedrv->name, "chasehq", 5))) {satconst=0.30;}
!     /*anything else*/
!     else {satconst=0;}
!     	
  	// switch off the type
  	switch (codetype)
  	{
***************
*** 1899,1904 ****
--- 1928,1935 ----
  		case CODETYPE_BUTTON:
  			return joystick_state[joynum].rgbButtons[joyindex] >> 7;
  
+ 
+ //SEGUONO LE DEFINIZIONI PER  "PADDLE DEC" E "PADDLE INC"
  		case CODETYPE_AXIS_POS:
  		case CODETYPE_AXIS_NEG:
  		{
***************
*** 1911,1921 ****
  			// FIXME in the two-axis joystick case, we need to find out
  			// the angle. Anything else is unprecise.
  			if (codetype == CODETYPE_AXIS_POS)
! 				return (val > middle + ((top - middle) * a2d_deadzone));
  			else
! 				return (val < middle - ((middle - bottom) * a2d_deadzone));
  		}
  
  		// anywhere from 0-45 (315) deg to 0+45 (45) deg
  		case CODETYPE_POV_UP:
  			pov = joystick_state[joynum].rgdwPOV[joyindex];
--- 1942,1977 ----
  			// FIXME in the two-axis joystick case, we need to find out
  			// the angle. Anything else is unprecise.
  			if (codetype == CODETYPE_AXIS_POS)
! 				return (val*(joy_saturation+satconst) > middle + ((top - middle) * a2d_deadzone));
! 			else
! 				return (val*(joy_saturation+satconst) < middle - ((middle - bottom) * a2d_deadzone));
!          }   
! 
! 
! //SEGUONO LE DEFINIZIONI PER  "PADDLE ANALOG"/ "AD STICK ANALOG"  
! 		// analog joystick axis
! 		case CODETYPE_JOYAXIS:
! 		{
! 			if (joystick_type[joynum][joyindex] != AXIS_TYPE_ANALOG)
! 				return ANALOG_VALUE_INVALID;
  			else
! 			{
! 				LONG val = ((LONG *)&joystick_state[joynum].lX)[joyindex];
! 				LONG top = joystick_range[joynum][joyindex].lMax;
! 				LONG bottom = joystick_range[joynum][joyindex].lMin;
! 				//LONG middle = (top + bottom) / 2;
! 
! 				if (!use_joystick)
! 					return 0;
! /*SATURATION*/	val = ((INT64)(val - bottom) * (INT64)(ANALOG_VALUE_MAX - ANALOG_VALUE_MIN) / (INT64)(top - bottom) + ANALOG_VALUE_MIN)*(joy_saturation+satconst);
! 				if (val < ANALOG_VALUE_MIN) {val = ANALOG_VALUE_MIN;}
! 			    if (val > ANALOG_VALUE_MAX) {val = ANALOG_VALUE_MAX;}
! /*DEADZONE*/	if (val > (ANALOG_VALUE_MAX + ANALOG_VALUE_MIN)/2 -30000*a2d_deadzone && val< (ANALOG_VALUE_MAX + ANALOG_VALUE_MIN)/2+30000*a2d_deadzone)  {val = (ANALOG_VALUE_MAX+ANALOG_VALUE_MIN)/2;}				
! 				return val;
! 			}
  		}
  
+ 
  		// anywhere from 0-45 (315) deg to 0+45 (45) deg
  		case CODETYPE_POV_UP:
  			pov = joystick_state[joynum].rgdwPOV[joyindex];
***************
*** 1936,1960 ****
  			pov = joystick_state[joynum].rgdwPOV[joyindex];
  			return ((pov & 0xffff) != 0xffff && (pov >= 22500 && pov <= 31500));
  
- 		// analog joystick axis
- 		case CODETYPE_JOYAXIS:
- 		{
- 			if (joystick_type[joynum][joyindex] != AXIS_TYPE_ANALOG)
- 				return ANALOG_VALUE_INVALID;
- 			else
- 			{
- 				LONG val = ((LONG *)&joystick_state[joynum].lX)[joyindex];
- 				LONG top = joystick_range[joynum][joyindex].lMax;
- 				LONG bottom = joystick_range[joynum][joyindex].lMin;
- 
- 				if (!use_joystick)
- 					return 0;
- 				val = (INT64)(val - bottom) * (INT64)(ANALOG_VALUE_MAX - ANALOG_VALUE_MIN) / (INT64)(top - bottom) + ANALOG_VALUE_MIN;
- 				if (val < ANALOG_VALUE_MIN) val = ANALOG_VALUE_MIN;
- 				if (val > ANALOG_VALUE_MAX) val = ANALOG_VALUE_MAX;
- 				return val;
- 			}
- 		}
  
  		// analog mouse axis
  		case CODETYPE_MOUSEAXIS:
--- 1992,1997 ----
diff -crB c:\mame0106s\mame0106s\src/windows/video.c c:\mingw9\mame\src/windows/video.c
*** c:\mame0106s\mame0106s\src/windows/video.c	Wed Apr 26 21:44:02 2006
--- c:\mingw9\mame\src/windows/video.c	Mon Mar 19 21:22:13 2012
***************
*** 198,211 ****
  {
  	// name, shortname, type, dest, deflt, min, max, func, help
  	{ "Windows video options", NULL, rc_seperator, NULL, NULL, 0, 0, NULL, NULL },
! 	{ "autoframeskip", "afs", rc_bool, &autoframeskip, "1", 0, 0, NULL, "skip frames to speed up emulation" },
  	{ "frameskip", "fs", rc_int, &frameskip, "0", 0, 12, NULL, "set frameskip explicitly (autoframeskip needs to be off)" },
  	{ "waitvsync", NULL, rc_bool, &win_wait_vsync, "0", 0, 0, NULL, "wait for vertical sync (reduces tearing)"},
  	{ "triplebuffer", "tb", rc_bool, &win_triple_buffer, "0", 0, 0, NULL, "triple buffering (only if fullscreen)" },
  	{ "window", "w", rc_bool, &win_window_mode, "0", 0, 0, NULL, "run in a window/run on full screen" },
  	{ "ddraw", "dd", rc_bool, &win_use_ddraw, "1", 0, 0, NULL, "use DirectDraw for rendering" },
  	{ "direct3d", "d3d", rc_bool, &win_use_d3d, "0", 0, 0, NULL, "use Direct3D for rendering" },
! 	{ "hwstretch", "hws", rc_bool, &win_dd_hw_stretch, "1", 0, 0, NULL, "(dd) stretch video using the hardware" },
  	{ "screen", NULL, rc_string, &screen_name, NULL, 0, 0, NULL, "specify which screen to use" },
  	{ "cleanstretch", "cs", rc_string, &cleanstretch, "auto", 0, 0, decode_cleanstretch, "stretch to integer ratios" },
  	{ "resolution", "r", rc_string, &resolution, "auto", 0, 0, video_set_resolution, "set resolution" },
--- 198,211 ----
  {
  	// name, shortname, type, dest, deflt, min, max, func, help
  	{ "Windows video options", NULL, rc_seperator, NULL, NULL, 0, 0, NULL, NULL },
! 	{ "autoframeskip", "afs", rc_bool, &autoframeskip, "0", 0, 0, NULL, "skip frames to speed up emulation" },
  	{ "frameskip", "fs", rc_int, &frameskip, "0", 0, 12, NULL, "set frameskip explicitly (autoframeskip needs to be off)" },
  	{ "waitvsync", NULL, rc_bool, &win_wait_vsync, "0", 0, 0, NULL, "wait for vertical sync (reduces tearing)"},
  	{ "triplebuffer", "tb", rc_bool, &win_triple_buffer, "0", 0, 0, NULL, "triple buffering (only if fullscreen)" },
  	{ "window", "w", rc_bool, &win_window_mode, "0", 0, 0, NULL, "run in a window/run on full screen" },
  	{ "ddraw", "dd", rc_bool, &win_use_ddraw, "1", 0, 0, NULL, "use DirectDraw for rendering" },
  	{ "direct3d", "d3d", rc_bool, &win_use_d3d, "0", 0, 0, NULL, "use Direct3D for rendering" },
! 	{ "hwstretch", "hws", rc_bool, &win_dd_hw_stretch, "0", 0, 0, NULL, "(dd) stretch video using the hardware" },
  	{ "screen", NULL, rc_string, &screen_name, NULL, 0, 0, NULL, "specify which screen to use" },
  	{ "cleanstretch", "cs", rc_string, &cleanstretch, "auto", 0, 0, decode_cleanstretch, "stretch to integer ratios" },
  	{ "resolution", "r", rc_string, &resolution, "auto", 0, 0, video_set_resolution, "set resolution" },
